#!/bin/sh
spitshell=cat
package="austhex8"
echo "Extracting $package/src/version.c..."

creation=`date | \
awk '{if (NF == 6) \
{ print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
{ print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

if test -r version.c.last ; then
 generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c.last`
 genesis=`sed -n 's/^char \*genesis = \"\(.*\)\";/\1/p' < version.c.last`
 if test ! "$generation" ; then 
  generation=0
 fi 
 if test ! "$genesis" ; then 
  genesis=$creation
 fi
else
 generation=0
 genesis=$creation
fi

generation=`expr $generation + 1`

uname=`uname -a | sed 's/$/\",/;s/^/   "/'`
ulimit=`ulimit -a | sed 's/$/\",/;s/^/   "/'`

creation=`date | \
awk '{if (NF == 6) \
{ print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
{ print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell > version.c <<!SUB!THIS!
/*
 *   IRC - Internet Relay Chat, src/version.c
 *   Copyright (C) 1990 Chelsea Ashley Dyerman
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "patchlevel.h"
#include "ircsprintf.h"
#include "init.h"

char *generation = "$generation";
char *creation = "$creation";
char version[128];

void build_version(void)
{

    ircsprintf(version, "austhex8-beta14");

}

char *infotext[] =
    {
	 "$package --",
	 "Based on the original code written by Jarkko Oikarinen",
	 "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
	 "",
	 "This program is free software; you can redistribute it and/or",
	 "modify it under the terms of the GNU General Public License as",
	 "published by the Free Software Foundation; either version 2, or",
	 "(at your option) any later version.",
	 "",
	 "More information available at http://ircd.austnet.org",
    "",
	 0,
};

char *copyrighttext[] =
    {
	"This program is free software; you can redistribute it and/or modify",
	"it under the terms of the GNU General Public License as published by",
	"the Free Software Foundation; either version 2 of the License, or",
	"(at your option) any later version.",
	"",
	"This program is distributed in the hope that it will be useful,",
	"but WITHOUT ANY WARRANTY; without even the implied warranty of",
	"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the",
	"GNU General Public License for more details.",
	"",
	"A copy of the GNU General Public License are distributed alongside all",
	"official releases of UltimateIRCd. It can also be obtained by writing to",
	"Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,",
	"MA  02111-1307 USA",
	"",
	 "More information available at http://ircd.austnet.org",
	"",
	 0,
};


char *uname_result[] = {
$uname
   0
};

char *ulimit_result[] = {
$ulimit
   0
};

!SUB!THIS!

